#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

static const byte[] ColorSource = {
    Char_Line_Normal, 8, 0x47,
    Char_Line_Red, 8, 0x42,
    Char_Point, 16, 0x47,
    Char_Man, 4, 0x45,
    Char_Monster, 16, 0x43,
    Char_Increaser, 4, 0x44,
    Char_Block, 4, 0x41,
    Char_Item, 4, 0x46,
    0xff
};

byte[256] CharColors;

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}

void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x07;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }

    SetPattern(Char_Line_Normal, Pattern_Line, 16);
    SetPattern(Char_Line_Red, Pattern_Line, 16);
    SetPattern(Char_Point, Pattern_Point, 4 * 4);
    SetPattern(Char_Man, Pattern_Man, 4);
    SetPattern(Char_Increaser, Pattern_Increaser, 4 * 3);
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, Char_Space);
    FillMemory(Attr, VramWidth * VramHeight, 0x07);
}


void Put2C(ptr<byte> pVram, byte c, byte color)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c, color);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
}
